/*
 * $Id: mon_focus_policy_class.java,v 1.7 1996/10/03 19:44:17 hudson Exp $
 * $Author: hudson $
 */

package sub_arctic.input;

import sub_arctic.lib.manager;

public class mon_focus_policy_class extends focus_policy_class {

  /* . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . */

  public mon_focus_policy_class()
    {
      /* nothing extra to do here */
    }

  /* . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . */

  public boolean dispatch_event(event evt)
    {
      dispatch_agent an_agent;

      /* walk down the agent list */
      for (int i = 0; i < num_agents(); i++)
	{
	  /* dispatch with the agent, but ignore the result. */
	  an_agent = (dispatch_agent)_agent_list.elementAt(i);
	  if (an_agent.event_is_useful(evt))
	    an_agent.dispatch_event(evt, null, null, manager.event_seq_num());
	}

      /* never consume the event */
      return false;
    }

  /* . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . */
}

/*=========================== COPYRIGHT NOTICE ===========================

This file is part of the subArctic user interface toolkit.

Copyright (c) 1996 Scott Hudson and Ian Smith
All rights reserved.

The subArctic system is freely available for most uses under the terms
and conditions described in 
  http://www.cc.gatech.edu/gvu/ui/sub_arctic/sub_arctic/doc/usage.html 
and appearing in full in the lib/interactor.java source file.

The current release and additional information about this software can be 
found starting at: http://www.cc.gatech.edu/gvu/ui/sub_arctic/

========================================================================*/
