/*
 * $Id: constraint_test.java,v 1.14 1996/10/03 19:46:51 hudson Exp $
 * $Author: hudson $
 */

package sub_arctic.test;

import sub_arctic.constraints.std_function;
import sub_arctic.lib.interactor_applet;
import sub_arctic.lib.manager;
import sub_arctic.lib.interactor;
import sub_arctic.lib.interactor_consts;
import sub_arctic.lib.top_level;
import sub_arctic.lib.icon;
import sub_arctic.lib.button;
import sub_arctic.lib.shadow_drag_container;
import sub_arctic.lib.drag_container;
import sub_arctic.lib.shrink_wrap_container;
import sub_arctic.output.style;
import sub_arctic.output.loaded_image;
import sub_arctic.output.style_manager;
import sub_arctic.lib.base_parent_interactor;


public class constraint_test extends interactor_applet 
implements interactor_consts {

  public void build_ui(base_parent_interactor top) 
    {
      shrink_wrap_container expand;
      loaded_image          images[];
      interactor            child, handle;
      style s = style_manager.current_style();
      child = new button(0,0, "Vertical Center", null);
      child.set_x_constraint(std_function.offset(NEXT_SIBLING.X2(), 4));
      child.set_y_constraint(std_function.centered(NEXT_SIBLING.H(), 0));
      top.add_child(child);

      expand = new shrink_wrap_container(2,2,5,true);
      top.add_child(expand);

      images = s.button_make_images("*",style_manager.default_font(),
				    10,5,false);
      child = new icon(300,10,images[0]);
      expand.add_child(child);

      child = new icon(10,50,images[0]);
      expand.add_child(child);

      images = s.
	button_make_images("Drag This to Demonstrate Dynamic Layout",
			   style_manager.default_font(),10,5,false);
      handle = new icon(0,0,images[0]);

	// child = new shadow_drag_container(5,5);
      child = new drag_container(5,5, false);
      child.add_child(handle);
      expand.add_child(child);

      child = new button(0,0, "Horiz Center", null);
      child.set_x_constraint(std_function.centered(PREV_SIBLING.W(), 0));
      child.set_y_constraint(std_function.offset(PREV_SIBLING.Y2(), 4));
      top.add_child(child);
    }
}

/*=========================== COPYRIGHT NOTICE ===========================

This file is part of the subArctic user interface toolkit.

Copyright (c) 1996 Scott Hudson and Ian Smith
All rights reserved.

The subArctic system is freely available for most uses under the terms
and conditions described in 
  http://www.cc.gatech.edu/gvu/ui/sub_arctic/sub_arctic/doc/usage.html 
and appearing in full in the lib/interactor.java source file.

The current release and additional information about this software can be 
found starting at: http://www.cc.gatech.edu/gvu/ui/sub_arctic/

========================================================================*/
