package sub_arctic.anim;

/**
 * This is the type of class you construct for a permanent transition.
 * This object has a start time, but no duration or stop time.<p>
 *
 * @author Ian Smith
 */
public class continuous_interval extends time_interval {

  /* . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . */

  /**
   * Construct a permanent time interval to begin at a given time.<p>
   * 
   * @param long start the start time
   */
  public continuous_interval(long start) {
    super(); // we'll fill them in
    set_start_time(start);
  }

  /* . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . */

  /**
   * This type of object is always valid, since we require all the
   * relevant fields at construction time.<p>
   *
   * @return boolean we always return true
   */
  public boolean valid() { return true;}

  /* . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . */
}
/*=========================== COPYRIGHT NOTICE ===========================

This file is part of the subArctic user interface toolkit.

Copyright (c) 1996 Scott Hudson and Ian Smith
All rights reserved.

The subArctic system is freely available for most uses under the terms
and conditions described in 
  http://www.cc.gatech.edu/gvu/ui/sub_arctic/sub_arctic/doc/usage.html 
and appearing in full in the lib/interactor.java source file.

The current release and additional information about this software can be 
found starting at: http://www.cc.gatech.edu/gvu/ui/sub_arctic/

========================================================================*/
