
package sub_arctic.output;

import java.awt.Color;

/** 
 * A class to hold a contrasting pair of colors (foreground and background).
 *
 * @author Scott Hudson
 */
public class color_pair {
  /* . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . */

  /** Foreground color of the pair */
  protected Color _foreground;

  /** Foreground color of the pair */
  public Color foreground() {return _foreground;}

  /* . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . */

  /** Background color of the pair */
  protected Color _background;

  /** Background color of the pair */
  public Color background() {return _background;}

  /* . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . */

  /** 
   * Simple constructor.
   *
   * @param Color fg foreground color for the pair.
   * @param Color bg background color for the pair.
   */
  public color_pair(Color fg, Color bg)
    {
      _foreground = fg;
      _background = bg;
    }

  /* . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . */

  /** 
   * Return a new color pair with the foreground and background reversed. 
   * @return color_pair the reversed color pair.
   */
  public color_pair inverted()
    {
      return new color_pair(_background, _foreground);
    }

  /* . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . */

  /** Standard color pair for black on white */
  public static final color_pair black_on_white = 
				 new color_pair(Color.black,Color.white);

  /* . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . */

  /** Standard color pair for white on black */
  public static final color_pair white_on_black = 
				 new color_pair(Color.white,Color.black);

  /* . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . */
}
/*=========================== COPYRIGHT NOTICE ===========================

This file is part of the subArctic user interface toolkit.

Copyright (c) 1996 Scott Hudson and Ian Smith
All rights reserved.

The subArctic system is freely available for most uses under the terms
and conditions described in 
  http://www.cc.gatech.edu/gvu/ui/sub_arctic/sub_arctic/doc/usage.html 
and appearing in full in the lib/interactor.java source file.

The current release and additional information about this software can be 
found starting at: http://www.cc.gatech.edu/gvu/ui/sub_arctic/

========================================================================*/
