
package sub_arctic.output;

import java.awt.image.ImageObserver;
import java.awt.Image;

/** 
 * An ImageObserver object which does nothing.  This is useful if you 
 * know that an image is already loaded and you don't expect any updates
 * (or otherwise wouldn't know what to do with one if you got it).
 *
 * @see java.awt.image.ImageObserver
 * @author Scott Hudson
 */
public class ignore_observer implements ImageObserver {

  /** Simple constructor */
  public ignore_observer() { }

  /**
   * Receive (and ignore) updates concerning the progress of loading the image.
   *
   * @param Image i     the image being ignored.
   * @param int   flags indication of image state/progress.
   * @param int   x     more information about the image.
   * @param int   y     more information about the image.
   * @param int   w     more information about the image.
   * @param int   h     more information about the image.
   * @return boolean always returns false indicating no additional updates are 
   *                 needed
   */
  public boolean imageUpdate(Image i, int flags, int x, int y, int w, int h)
    {return false;}
}
  
/*=========================== COPYRIGHT NOTICE ===========================

This file is part of the subArctic user interface toolkit.

Copyright (c) 1996 Scott Hudson and Ian Smith
All rights reserved.

The subArctic system is freely available for most uses under the terms
and conditions described in 
  http://www.cc.gatech.edu/gvu/ui/sub_arctic/sub_arctic/doc/usage.html 
and appearing in full in the lib/interactor.java source file.

The current release and additional information about this software can be 
found starting at: http://www.cc.gatech.edu/gvu/ui/sub_arctic/

========================================================================*/
