/**
 * This is an example program which displays an HTML document
 * in a text_flow.
 */
package sub_arctic.test;

import sub_arctic.lib.*;
import sub_arctic.output.*;
import sub_arctic.input.*;
import sub_arctic.constraints.std_function;

import java.awt.Font;

/**
 * This is an example program which displays an HTML document
 * in a text_flow.
 * 
 * @author Ian Smith 
 * @version $Id: flow_test.java,v 1.10 1996/10/03 19:46:51 hudson Exp $
 */
public class flow_test extends debug_interactor_applet {
  public void build_ui(base_parent_interactor top) {
    text_flow tf;
    panner p;
    /* build the flow */
    tf=new text_flow(null,580);
    /* make a panner with this object in it */
    p=new panner(tf);
    // put the flow in 
    top.add_child(p);
    /* now position it */
    p.set_x(10);
    p.set_y(10);
    p.set_w_constraint(std_function.offset(PARENT.X2(), -20));
    p.set_h_constraint(std_function.offset(PARENT.Y2(), -20));
    /* now set the text */
    tf.set_text(getParameter("text"));
    System.out.println("Width is now: " + tf.w());
  }
}
/*=========================== COPYRIGHT NOTICE ===========================

This file is part of the subArctic user interface toolkit.

Copyright (c) 1996 Scott Hudson and Ian Smith
All rights reserved.

The subArctic system is freely available for most uses under the terms
and conditions described in 
  http://www.cc.gatech.edu/gvu/ui/sub_arctic/sub_arctic/doc/usage.html 
and appearing in full in the lib/interactor.java source file.

The current release and additional information about this software can be 
found starting at: http://www.cc.gatech.edu/gvu/ui/sub_arctic/

========================================================================*/
