/**
 * This is an example program which shows how to use the listbox class.
 */
package sub_arctic.test;

import sub_arctic.lib.*;
import sub_arctic.output.*;
import sub_arctic.input.*;
import sub_arctic.anim.*;

import java.util.Vector;

public class listbox_test extends debug_interactor_applet implements timer, callback_object {
  base_parent_interactor _top;
  text_list_element elem;

  String[] releases={"Billings (version 0.7i)",
		     "St. Paul (version 0.7k)",
		     "Minneapolis (version 0.8a)",
		     "Edmonton (version 0.9a)",
		     "Nome (version ONE POINT OH)"};
  String[] releases_longer={"Billings (version 0.7i)",
			    "St. Paul (version 0.7k)",
			    "Minneapolis (version 0.8a)",
			    "Edmonton (version 0.9a)",
			    "Nome (version ONE POINT OH)",
			    "DON'T KNOW",
			    "DON'T KNOW AGAIN",
			    "DON'T KNOW A THIRD TIME",
			    "Sydney (version 1.8a)",
			    "CapeTown (version 1.9a",
			    "Antarctic Sea (version 2.0a)"};

  public void build_ui(base_parent_interactor top) {
    Vector v1,v2,v3,v4;
    listbox ld=new listbox(150,100,false,null),
      ld2=new listbox(250,200,false,this),
      ld3=new listbox(90,200,false,this),
      ld4=new listbox(230,60,false,null);
    _top=top;
    v1=text_list_element.make_contents_vector(releases_longer,null);
    v2=text_list_element.make_contents_vector(releases_longer,null);
    v3=text_list_element.make_contents_vector(releases_longer,null);
    v4=text_list_element.make_contents_vector(releases_longer,null);

    /* first ...tricky case: this object needs both scrollbars*/
    top.add_child(ld);
    ld.set_x(10);
    ld.set_y(10);
    ld.set_contents(v1);
    ld.set_horizontal_status(listbox_display.SCROLLBAR_AS_NECESSARY);
    // tricky test: if you uncomment this line, you lose both
    // scrollbars because the vertical is no longer needed without
    // the horizontal
    // ld.set_horizontal_status(listbox_display.SCROLLBAR_NEVER);
    /* second : this object should have only vertical scrollbar*/
    top.add_child(ld2);
    ld2.set_x(10);
    ld2.set_y(130);
    v2.addElement(new object_list_element(top));
    ld2.set_contents(v2);
    ld2.set_single_selection(true);
    // test forcing the scrollbars
    //ld2.set_horizontal_status(listbox_display.SCROLLBAR_ALWAYS);
    //ld2.set_vertical_status(listbox_display.SCROLLBAR_ALWAYS);
    /* third : this object should have only a vertical*/
    top.add_child(ld3);
    ld3.set_x(270);
    ld3.set_y(10);
    ld3.set_vertical_status(listbox_display.SCROLLBAR_ALWAYS);
    ld3.set_contents(v3);
    /* fourth : this object should have only a vertical*/
    top.add_child(ld4);
    ld4.set_x(270);
    ld4.set_y(220);
    ld4.set_contents(v4);
    // if you use the following test line, you should only be able to 
    // see two lines in the window
    // ld4.set_horizontal_status(listbox_display.SCROLLBAR_ALWAYS);

    /* get ready for callback */
    elem=(text_list_element)v1.elementAt(3);
  }
  public void post_build_ui(base_parent_interactor ignored) {
    timer_transition tt=new timer_transition(this,5000);
    manager.animation.schedule_transition(tt);
  }
  public void time_expired(event evt /* ingored */) {
    /* make an object selected when the time expires */
    Vector s=new Vector();
    listbox_display ldc=(listbox_display)_top.child(0);
    s.addElement(elem);
    ldc.set_selected(s);
  }
  /**
   * Print out the callbacks.
   */
  public void callback(
    interactor from_obj, 
    event      evt,
    int        callback_num, 
    Object     callback_info){

    System.out.print("Callback: " );
    if (callback_num==listbox.DRAG) {
      System.out.println("DRAG");
    }
    if (callback_num==listbox.DOUBLE_CLICK) {
      System.out.println("DOUBLE_CLICK");
    }
    if (callback_num==listbox.SINGLE_CLICK_PENDING) {
      System.out.println("SINGLE_CLICK_PENDING");
    }
    if (callback_num==listbox.SINGLE_CLICK_FINAL) {
      System.out.println("SINGLE_CLICK_FINAL");
    }
  }

}
/*=========================== COPYRIGHT NOTICE ===========================

This file is part of the subArctic user interface toolkit.

Copyright (c) 1996 Scott Hudson and Ian Smith
All rights reserved.

The subArctic system is freely available for most uses under the terms
and conditions described in 
  http://www.cc.gatech.edu/gvu/ui/sub_arctic/sub_arctic/doc/usage.html 
and appearing in full in the lib/interactor.java source file.

The current release and additional information about this software can be 
found starting at: http://www.cc.gatech.edu/gvu/ui/sub_arctic/

========================================================================*/
