/**
 * This is an example program which shows how to allow objects like
 * buttons and labels to resize.
 */
package sub_arctic.test;

import sub_arctic.lib.*;
import sub_arctic.output.*;
import sub_arctic.input.*;
import sub_arctic.constraints.std_function;

import java.awt.Font;

/**
 * This is an example program which shows how to allow objects like
 * buttons and labels to resize.
 * 
 * @author Ian Smith 
 * @version $Id: size_test.java,v 1.7 1996/10/03 19:46:51 hudson Exp $
 */
public class size_test extends interactor_applet {
  public void build_ui(base_parent_interactor top) {
    button b=new button("Testing 1 2 3",null);
    label l=new label("This is also a test");
      
    l.set_autosize(false);
    l.set_w_constraint(std_function.offset(PARENT.W(), -2));
    l.set_x_constraint(std_function.offset(PARENT.X(), 1));
    l.set_y_constraint(std_function.far_edge_just(PARENT.Y2(), 1));

    b.set_autosize(false);
    b.set_w_constraint(std_function.offset(PARENT.W(), -2));
    b.set_x_constraint(std_function.offset(PARENT.X(), 1));
    b.set_h_constraint(std_function.fill(PARENT.Y(), NEXT_SIBLING.Y(), 1));
    b.set_y_constraint(std_function.offset(PARENT.Y(), 1));

    top.add_child(b);
    top.add_child(l);
  }
}
/*=========================== COPYRIGHT NOTICE ===========================

This file is part of the subArctic user interface toolkit.

Copyright (c) 1996 Scott Hudson and Ian Smith
All rights reserved.

The subArctic system is freely available for most uses under the terms
and conditions described in 
  http://www.cc.gatech.edu/gvu/ui/sub_arctic/sub_arctic/doc/usage.html 
and appearing in full in the lib/interactor.java source file.

The current release and additional information about this software can be 
found starting at: http://www.cc.gatech.edu/gvu/ui/sub_arctic/

========================================================================*/
