
package sub_arctic.test;

import sub_arctic.lib.interactor;
import sub_arctic.lib.interactor_applet;
import sub_arctic.lib.manager;
import sub_arctic.lib.interactor_consts;
import sub_arctic.lib.base_parent_interactor;
import sub_arctic.lib.top_level;
import sub_arctic.lib.sliding_stylized_text;
import sub_arctic.input.callback_object;
import sub_arctic.input.event;
import sub_arctic.output.color_pair;
import sub_arctic.anim.transition;
import sub_arctic.anim.line_trajectory;
import sub_arctic.anim.linear_pacer;
import sub_arctic.anim.time_interval;

public class sliding_styl_text_test extends interactor_applet 
implements interactor_consts, callback_object {

  public StringBuffer message = new StringBuffer();

  public void build_ui(base_parent_interactor top) 
    {
      sliding_stylized_text t;
      int          TRIAL_SIZE = 15;
      long         now;
      int          dist;
      transition   trans;
      String       tag = "This is a test of sliding " + 
      "<b>bold</b> <i>italic</i> <b><i>bold-italic</b></i> " + 
      "<red>red</red> <white>white</white> and <blue>blue</blue> text... ";

      for (int i = 1; i <= TRIAL_SIZE; i++)
	{
	  message.append("("); 
	  message.append(i); 
	  message.append(")");
	  message.append(tag);
	}
      message.append("[end]");

      
      System.out.println("Building object"); System.out.flush();
      t = new sliding_stylized_text(message.toString(), 350, this);
      System.out.println("Adding object"); System.out.flush();
      t.set_pos(10,10);
      top.add_child(t);


      System.out.println("Starting Animation (size = "+TRIAL_SIZE+") ...");

      dist = t.text_length()-20;
      now = time_interval.now();
      trans  = new transition(t, new time_interval(now,now+10*dist), 
			      new line_trajectory(0,0, dist, 0, new linear_pacer()));
      manager.animation.schedule_transition(trans);

    }

  public void callback(
    interactor       from_obj, 
    event            evt,
    int              callback_num, 
    Object           callback_info)
    {
      long         now;
      int          dist;
      transition   trans;
      sliding_stylized_text t;

      t = (sliding_stylized_text)from_obj;
      System.out.println("END OF SCROLL starting over");
      t.set_text(message.toString());
      dist = t.text_length()-20;
      now = time_interval.now();
      trans  = new transition(t, new time_interval(now,now+10*dist), 
	              new line_trajectory(0,0, dist, 0, new linear_pacer()));
      manager.animation.schedule_transition(trans);
  }
}

/*=========================== COPYRIGHT NOTICE ===========================

This file is part of the subArctic user interface toolkit.

Copyright (c) 1996 Scott Hudson and Ian Smith
All rights reserved.

The subArctic system is freely available for most uses under the terms
and conditions described in 
  http://www.cc.gatech.edu/gvu/ui/sub_arctic/sub_arctic/doc/usage.html 
and appearing in full in the lib/interactor.java source file.

The current release and additional information about this software can be 
found starting at: http://www.cc.gatech.edu/gvu/ui/sub_arctic/

========================================================================*/
